<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SenderProvidedRequestData StructType
 * @subpackage Structs
 */
class SenderProvidedRequestData extends AbstractStructBase
{
    /**
     * The Sender
     * Meta information extracted from the WSDL
     * - ref: tns:Sender
     * @var \StructType\Sender
     */
    public $Sender;
    /**
     * The MessagePrimaryContent
     * Meta information extracted from the WSDL
     * - ref: ns1:MessagePrimaryContent
     * @var \StructType\MessagePrimaryContent
     */
    public $MessagePrimaryContent;
    /**
     * Constructor method for SenderProvidedRequestData
     * @uses SenderProvidedRequestData::setSender()
     * @uses SenderProvidedRequestData::setMessagePrimaryContent()
     * @param \StructType\Sender $sender
     * @param \StructType\MessagePrimaryContent $messagePrimaryContent
     */
    public function __construct(\StructType\Sender $sender = null, \StructType\MessagePrimaryContent $messagePrimaryContent = null)
    {
        $this
            ->setSender($sender)
            ->setMessagePrimaryContent($messagePrimaryContent);
    }
    /**
     * Get Sender value
     * @return \StructType\Sender|null
     */
    public function getSender()
    {
        return $this->Sender;
    }
    /**
     * Set Sender value
     * @param \StructType\Sender $sender
     * @return \StructType\SenderProvidedRequestData
     */
    public function setSender(\StructType\Sender $sender = null)
    {
        $this->Sender = $sender;
        return $this;
    }
    /**
     * Get MessagePrimaryContent value
     * @return \StructType\MessagePrimaryContent|null
     */
    public function getMessagePrimaryContent()
    {
        return $this->MessagePrimaryContent;
    }
    /**
     * Set MessagePrimaryContent value
     * @param \StructType\MessagePrimaryContent $messagePrimaryContent
     * @return \StructType\SenderProvidedRequestData
     */
    public function setMessagePrimaryContent(\StructType\MessagePrimaryContent $messagePrimaryContent = null)
    {
        $this->MessagePrimaryContent = $messagePrimaryContent;
        return $this;
    }
}
